#!/usr/bin/python
# -*- coding: iso-8859-1 -*-

#____________________________________________________________________________
# ACTOS
# Asterisk Configuration Tool Open Source
# Copyright (c) EOLE - Mai 2004 - Pierre Derrier
#____________________________________________________________________________
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#____________________________________________________________________________
# ACTOS.PY : PRINCIPAL MODULE
#____________________________________________________________________________
# Notes: 
#
#
#
#
#
#
#
#
#
#
#
#
#____________________________________________________________________________


#Helpful tip from Anthony Baxter (author of 'Shtoom')
import sys; sys.path.append(sys.path.pop(0))

#____________________________________________________________________________
# EXTERN DEPENDENCIES
#____________________________________________________________________________
from actos_modules.Global import GLOBAL,_
from actos_modules import Tools
from actos_modules import Filesystem
from actos_modules import Context
#____________________________________________________________________________


#____________________________________________________________________________
# PRINCIPAL BLOC
#____________________________________________________________________________
if __name__ == "__main__":
#    """ Main program """

    #Welcome message
    Tools.Interface.AboutMessage()
    
    #Load and apply current ACTOS configuration
    Filesystem.load_actos_config()

    #Init global datas
    GLOBAL.ListeUsers=[]
    GLOBAL.ListeContextes=[]

    #import actions list and channel_vars list
    if not Tools.import_defs():
        Tools.debug("Error during init")
        sys.exit(1)
        
    Tools.debug("Init OK")

    Tools.debug("-------------- BEGINNING OF PROGRAM -------------")
        
    #auto import
    if GLOBAL.GLOBAL_PARAMS["autoimport"]=="yes":
        message=_("MSG_CONFIRM_IMPORT",[GLOBAL.GLOBAL_PARAMS["configdir"]])
        result=Tools.Interface.DialogBox(message,type_buttons=Tools.Interface.gtk.BUTTONS_YES_NO,type_dialog=Tools.Interface.gtk.MESSAGE_QUESTION)
        if result==Tools.Interface.gtk.RESPONSE_YES:
            Filesystem.load_asterisk_config(False)

    #try to load most used actions
    try:
        fh=open(GLOBAL.PREFIXDIR+"most_used_actions","r")
        file=fh.readlines()
        fh.close()
        Tools.debug(_("MSG_NB_FOUND_ACTIONS",[str(len(file))]))
        for line in file:
            line=line.split("/")
            act=line[0]
            val=int(line[1])
            GLOBAL.ACTIONS_MOSTUSED[act]=val
    except:
        Tools.debug("Can't load most used actions")

    #Create GUI
    App=Tools.Interface.InterfaceContainer(GLOBAL.PREFIXDIR+"glade/"+GLOBAL.GLADE_FILE[GLOBAL.GLOBAL_PARAMS["language"]])

    #launch interface
    App.run()

    #end of program
    if GLOBAL.GLOBAL_PARAMS["autoexport"]=="yes":
        Filesystem.save_asterisk_config()

    if GLOBAL.GLOBAL_PARAMS["autosavemostusedactions"]=="yes":
        try:
            fh=open(GLOBAL.PREFIXDIR+"most_used_actions","w")
            for act in GLOBAL.ACTIONS_MOSTUSED.keys():
                fh.write(act+"/"+str(GLOBAL.ACTIONS_MOSTUSED[act])+"\n")
            fh.close()
            
        except:
            Tools.debug("-- Error : "+_("ERROR_SAVE_ACTIONS"))

    #Write in file actos.conf
    Filesystem.save_actos_config()
    
    Tools.debug("----------------- END OF PROGRAM ----------------")
    Tools.debug_close()
    print _("MSG_QUIT")

#____________________________________________________________________________

