#!/usr/bin/python
# -*- coding: iso-8859-1 -*-


#_______________________________________________________________
# ACTOS
# Asterisk Configuration Tool Open Source
# (c) EOLE - Mai 2004 - Pierre Derrier
#_______________________________________________________________
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#____________________________________________________________________________
# INTERFACE.PY : GUI CONTAINER AND CONSTRUCTOR
#_______________________________________________________________
# Contains :
#            CLASS Interface
#                   GUI Constructor
#
#            FUNCTION AboutMessage()
#                   Show a welcome message
#_______________________________________________________________


import sys
#_______________________________________________________________
#CHECK GTK SUPPORT
#_______________________________________________________________
try:
    import gtk,gtk.glade
except:
    print "Verify that pyGtk and libglade are correctly installed. See http://rpmfind.net/linux/RPM/PLD/dists/ac/ready/Libraries_Python.html"
    sys.exit(1)

try:
    import gobject
except:
    print "Gobject module for python is not installed. You can download it at http://rpmfind.net/linux/RPM/PLD/dists/ac/ready/Libraries_Python.html"
    sys.exit(1)
#_______________________________________________________________


#_______________________________________________________________
# EXTERN DEPENDENCIES
#_______________________________________________________________
#_______________________________________________________________


#_______________________________________________________________
def AboutMessage():
    """ Show a message with name of program and authors """
#_______________________________________________________________
    print "\n________________________________________"
    print "ACTOS"
    print "Asterisk Configuration Tool Open Source"
    print "(c) EOLE - May/July 2004 - Pierre Derrier"
    print "________________________________________\n"
#_______________________________________________________________



#_______________________________________________________________
def DialogBox(texte,type_buttons=gtk.BUTTONS_OK,type_dialog=gtk.MESSAGE_INFO):
    #create a message box
#_______________________________________________________________
#type_buttons=
# BUTTONS_NONE, BUTTONS_OK, BUTTONS_CANCEL, BUTTONS_OK_CANCEL, BUTTONS_YES_NO, BUTTONS_CLOSE
#type_dialog=
# MESSAGE_INFO, MESSAGE_WARNING, MESSAGE_QUESTION, MESSAGE_ERROR
    texte=unicode(texte,"iso-8859-1")
    dial=gtk.MessageDialog(None,gtk.DIALOG_MODAL,buttons=type_buttons,type=type_dialog,message_format=texte.encode("UTF-8"))
    if type_buttons==gtk.BUTTONS_YES_NO:
        dial.set_default_response(gtk.RESPONSE_YES)
    ret = dial.run()
    dial.destroy()
    return ret
#_______________________________________________________________


#_______________________________________________________________
class InterfaceContainer:
    """ Class container of GUI """
#_______________________________________________________________

    #____________________________
    def __init__(self,gladefile):
    #____________________________
        #Parse GLADE file
        self.glade = gtk.glade.XML(gladefile)
        self.name = "__INTERFACE__"
        self.widget = None

    #____________________________
    def run(self):
    #____________________________
        from Windows import WMainCtrl
        #Create main window
        Win_Main=WMainCtrl(self)
        #Launch GTK loop
        try:
            gtk.main()
        except:
            gtk.mainloop()

    #____________________________
    def close(self):
    #____________________________
        try:
            gtk.main_quit()
        except:
            gtk.mainquit()
#_______________________________________________________________




#_______________________________________________________________
# IF SOMEONE LAUNCH THIS SCRIPT.... 
#_______________________________________________________________
if __name__ == "__main__":
    AboutMessage()
    print "Please launch actos.py\n"
#_______________________________________________________________
