#!/usr/bin/python
# -*- coding: iso-8859-1 -*-

#_____________________________________________________________________________
# ACTOS
# Asterisk Configuration Tool Open Source
# (c) EOLE - Mai 2004 - Pierre Derrier
#_____________________________________________________________________________
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#____________________________________________________________________________
# USER.PY : CONTAINER FOR USER DATAS
#____________________________________________________________________________
# Contains :
#            CLASS User
#
#____________________________________________________________________________



#_______________________________________________________________
# EXTERN DEPENDENCIES
#_______________________________________________________________
from Global import GLOBAL
import Tools
#_______________________________________________________________


#_______________________________________________________________
class User:
    """Definition des utilisateurs"""
#_______________________________________________________________
    
    #_________________________________________
    def __init__(self,name="anonymous",keys={"secret":"guest","host":"dynamic","type":"friend","context":"default"},protocol="sip",register=False,registerext=""):
        """ Constructeur de la classe User """
    #_________________________________________
        self.name=name
        self.params=keys
        self.protocol = protocol
        self.registerwith = register

        templiste=GLOBAL.COLUMN_OF_TABLE_USERS[2:]
        templiste.extend(GLOBAL.OPTIONS_USER)

        if self.protocol=="agent":
            for p in self.params.keys():
                if p not in ["login","secret","type","protocol","name"]:
                    self.params[p]=""
            Tools.debug("# New User instance (agent)"+str(self.name))
            return

        for i in templiste:
            if not i in self.params.keys():
                self.params[i]=GLOBAL.DEFAULTS_NEW_USER[i]

        #Dfinition de l'accountcode
        if not "accountcode" in self.params.keys():
            if self.params["login"]=="":
                self.params["accountcode"]=self.name
            else:
                self.params["accountcode"]=self.params["login"]

        #Definition de l'username et de fromuser
        if "username" in self.params.keys():
            if self.params["login"]=="":
                self.params["login"]=self.params["username"]
        else:
            self.params["username"]=self.params["login"]

        if "fromuser" not in self.params.keys():
            self.params["fromuser"]=self.params["username"]

        #Dfinition du callerid 
        #if "callerid" not in self.params.keys():
        #    self.params["callerid"]="\""+self.params["username"]+"\" <"+self.params["accountcode"]+">"
        #elif self.params["callerid"]=="":
        #    self.params["callerid"]="\""+self.params["username"]+"\" <"+self.params["accountcode"]+">"
                
        #define register string
        self.registerstring = self.params["username"]+":"+self.params["secret"]+"@"+self.params["host"]
        if registerext!="":
            self.registerstring+="/"+registerext

        #Dfinition du reste des dfauts
        reste = GLOBAL.DEFAULTS_NEW_USER.keys()
        reste.remove("name")
        reste.remove("protocol")
        for d in reste:
            if not d in self.params.keys():
                self.params[d]=GLOBAL.DEFAULTS_NEW_USER[d]
        
        Tools.debug("# New User instance "+str(self.name))
        if self.registerwith:
            Tools.debug("--> Register with : "+self.registerstring)
    #_________________________________________
    
   
    #_________________________________________
    def getRegisterExt(self):
    #_________________________________________
        str=self.registerstring
        str=str.split("/")
        if len(str)>1 and self.registerwith:
            return str[1].strip()
        else:
            return ""
    #_________________________________________


    #_________________________________________
    def affiche(self):
        """ Affiche un utilisateur """
    #_________________________________________
        print "("+self.protocol+") ["+self.name+"]"
        for k in self.params:
            if self.params[k]!="":
                params=self.params[k].split("##")
                for param in params:
                    print k+" = "+param
    #_________________________________________
    


    #_________________________________________
    def toString(self):
        """ Renvoie sous forme de chaine de caractres"""
    #_________________________________________
        if self.protocol=="agent":
            return "agent => "+self.params["login"]+","+self.params["secret"]+","+self.name+"\n"
    
        chaine="["+self.name+"]\n"

        #codecs first
        if self.params.get("disallow","")=="all":
            chaine+="disallow = all\n"
            codecs=self.params.get("allow","")
            if codecs!="":
                codecs=codecs.split("##")
                for codec in codecs:
                    chaine+="allow = "+codec+"\n"
                
                
        elif self.params.get("allow","")=="all":
            chaine+="allow = all\n"
            codecs=self.params.get("disallow","")
            if codecs!="":
                codecs=codecs.split("##")
                for codec in codecs:
                    chaine+="disallow = "+codec+"\n"

            
        for k in self.params.keys():
            if self.params[k]!="" and k not in ["allow","disallow"]:
                params=self.params[k].split("##")
                for param in params:
                    chaine+= k+" = "+param+"\n"
        return chaine+"\n"
    #_________________________________________


        
    #_________________________________________
    def toActosString(self):
        """ Convertit en un format compact pour la sauvegarde"""
    #_________________________________________
        return "USER#"
        # A FAIRE !!!
    #_________________________________________
        
#_______________________________________________________________



#_______________________________________________________________
# IF SOMEONE LAUNCH THIS SCRIPT.... 
#_______________________________________________________________
if __name__ == "__main__":
    Tools.Interface.AboutMessage()
    print "Please launch actos.py\n"
#_______________________________________________________________

