
# Copyright (C) 2004 Pierre Derrier

from distutils.core import setup
try:
    import py2exe
except:
    py2exe = None


from actos_modules import Version

class DependencyFailed(Exception): pass
class VersionCheckFailed(DependencyFailed): pass

import sys
if sys.version < '2.3':
    raise VersionCheckFailed, "Python 2.3 or higher is required"

try:
    import xmlrpclib
except ImportError:
    raise DependencyFailed, "You need xmlrpclib package for Python"

try:
    import BaseHTTPServer
except ImportError:
    raise DependencyFailed, "You need BaseHTTPServer package for Python"

try:
    import SocketServer
except ImportError:
    raise DependencyFailed, "You need SocketServer package for Python"


try:
    import gtk
except ImportError:
    raise DependencyFailed, "You need pyGTK 2.0 or higher - http://www.pygtk.org/"

try:
    import gtk.glade
except ImportError:
    raise DependencyFailed, "You need libglade 2.0 or higher- http://ftp.gnome.org/pub/GNOME/sources/libglade/2.0/"

try:
    import gobject
except ImportError:
    raise DependencyFailed, "You need gobject package - http://rpmfind.net/linux/RPM/PLD/dists/ac/ready/Libraries_Python.html"

if py2exe is not None:
    addnl = { 'console':['actos.py'], 
              'windows': [ { 'script':'actos.py',
		             'icon_resources' : [( 1, 'actos.ico')] } ] }
else:
    addnl = {}

setup(
    name = "actos",
    version = Version,
    description = "ACTOS - Asterisk Configuration Tool Open Source",
    author = "Pierre Derrier",
    author_email = "neoh@bonbon.net",
    url = 'http://membres.lycos.fr/belikewater/actos.html',
    packages = ['actos_modules'],
    scripts = ['actos.py'],
    data_files = [ ('/usr/share/actos/', ['actos.conf','actions.def','channelvars.def','fr.help','en.help','AUTHORS','CHANGELOG','KNOWN_BUGS','TODO','COPYING','INSTALL','README']),
                   ('/usr/share/actos/glade',['glade/actos_en.glade','glade/actos_fr.glade']),
                   ('/usr/share/actos/scripts',['scripts/fastbusy.actos','scripts/utils.actos'])],
    classifiers = [
       'Development Status :: 2 - Alpha',
       'License :: OSI Approved :: GNU Library or General Public License (GPL)',
       'Operating System :: POSIX',
       'Operating System :: Microsoft :: Windows',
       'Operating System :: MacOS :: MacOS X',
       'Programming Language :: Python',
       'Topic :: Internet',
       'Topic :: Communications :: Internet Phone',
    ],
    **addnl
)
